/*
	Copyright 2009-2020, Sumeet Chhetri 
  
    Licensed under the Apache License, Version 2.0 (the "License"); 
    you may not use this file except in compliance with the License. 
    You may obtain a copy of the License at 
  
        http://www.apache.org/licenses/LICENSE-2.0 
  
    Unless required by applicable law or agreed to in writing, software 
    distributed under the License is distributed on an "AS IS" BASIS, 
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
    See the License for the specific language governing permissions and 
    limitations under the License.  
*/
/*
 * Component.cpp
 *
 *  Created on: Jan 29, 2010
 *      Author: sumeet
 */

#include "Component.h"

Component::Component() {
	ajaxAvail = false;
	websAvail = false;
	methinvAvail = false;
	autoTranx = false;
	thrdPerReq = false;
	authMode = false;
	session = false;
	thrdPoolSize = 0;
	dbconpoolSize = 0;
	chib = NULL;
}

Component::~Component() {
}


void Component::startTransaction()
{
	getDataSource()->startTransaction();
}

void Component::endTransaction()
{
	getDataSource()->commit();
}

void Component::commit()
{
	getDataSource()->commit();
}

void Component::rollback()
{
	getDataSource()->rollback();
}

void Component::execute()
{
}

DataSourceInterface* Component::getDataSource()
{
	return chib;
}
